<?php







global $LDAP_LOGIN;
global $LDAP_LOGIN_FIELDS;
global $SETTINGS;

$ldapun = $LDAP_LOGIN["login"];
$ldappw = $LDAP_LOGIN["pw"];
$ldapdc = $LDAP_LOGIN["basedn"];
$ldapserver = $LDAP_LOGIN["server"];
$groupfilter = $LDAP_LOGIN_FIELDS["groupfilter"];

$groupuser = array("none" => array("none" => "none"));
$usergroup = array("none");

$debug = false;


$logging = false;
$logfile = "/Node/node/log/ldapsync.log";
if ($logging) $loghandler = fopen($logfile,'a') or halt(7, "ldap_groups: can't open logfile");

$ldapconn = ldap_connect($ldapserver) or halt(7, "ldap_groups: Could not connect to LDAP server.");

if ($logging) fwrite($loghandler, date("d.m.y H:i:s")." starting ldapgroupsync ...\r\n");








function explode_dn($dn, $with_attributes=0) {
 $result = ldap_explode_dn($dn, $with_attributes);
 foreach($result as $key => $value) $result[$key] = preg_replace("/\\\([0-9A-Fa-f]{2})/e", "''.chr(hexdec('\\1')).''", $value);
 return $result;
}







function get_members($group, $ldapconn, $ldapdc) {
 global $LDAP_LOGIN_FIELDS;

 $results = ldap_search($ldapconn, $ldapdc, "cn=".$group);
 $member_list = ldap_get_entries($ldapconn, $results);
 $dirty = 0;
 $count = 0;
 $group_member_details = array();
 $tempgroupuser = array($group);

 if ($LDAP_LOGIN_FIELDS['dontuse_uniquememberattribute']) {
 $ldapLoginField = strtolower($LDAP_LOGIN_FIELDS["login"]);

 if (count($member_list[0]['member']) > 0) {
 foreach($member_list[0]['member'] as $member) {
 
 if ($dirty == 0) {
 $dirty = 1;
 } else {
 $member_dn = explode_dn($member);
 $member_cn = str_ireplace("CN=","",$member_dn[0]);

 $member_search = ldap_search($ldapconn, $ldapdc, "cn=" . $member_cn);
 $member_details = ldap_get_entries($ldapconn, $member_search);

 $group_member_details[] = array($member_details[0][$ldapLoginField]);
 $tempgroupuser[$group][] = array($member_details[0][$ldapLoginField]);
 $mid = strtolower($member_details[0][$ldapLoginField][0]);

 $GLOBALS["usergroup"][(string)$mid][] = $group; 
 }
 }
 }
 } else {
 if (count($member_list[0]['uniquemember']) > 0) {
 foreach($member_list[0]['uniquemember'] as $member) {
 if($dirty == 0) {
 $dirty = 1;
 } else {
 $member_dn = explode_dn($member);
 $member_cn = str_replace("CN=","",$member_dn[0]);
 $member_search = ldap_search($ldapconn, $ldapdc, $member_cn);
 $member_details = ldap_get_entries($ldapconn, $member_search);
 $group_member_details[] = array($member_details[0]['uid']);
 $tempgroupuser[$group][] = array($member_details[0]['uid']);
 $mid = strtolower($member_details[0]['uid'][0]);
 $GLOBALS["usergroup"][(string)$mid][] = $group; 
 }
 }
 }
 }

 $mergegroupuser = array_merge($GLOBALS["groupuser"], $tempgroupuser);
 $GLOBALS["groupuser"] = $mergegroupuser;
}








function get_groups($get_all_members, $ldapconn, $ldapdc, $groupfilter) {
 $results = ldap_search($ldapconn, $ldapdc, $groupfilter);
 $group_list = ldap_get_entries($ldapconn, $results);
 $dirty = 0;
 if ($get_all_members) {
 foreach($group_list as $group) {
 if ($dirty == 0) {
 $dirty = 1;
 } else {
 get_members($group['cn'][0], $ldapconn, $ldapdc);
 }
 }
 }
 return $group_list;
}






function get_usergroup($user) {
 $lowerUser = strtolower($user);
 return $GLOBALS["usergroup"][$lowerUser];
}






function get_cmsgroupid($groupname) {
 $ids = array();
 $sql = "select id from usergroup where description = '".sqlslashes($groupname)."'";
 $rs = query($sql);
 foreach ($rs['arr'] as $id => $row) { 
 $ids[] = $row['id'];
 }
 return $ids[0];
}






function get_usergroupids($user) {
 global $loghandler;
 $rids = array();
 $tusergroup = get_usergroup($user);
 foreach ($tusergroup as $ftusergroup) {
 $usergroupId = get_cmsgroupid($ftusergroup);

 
 if (!empty($usergroupId) && $usergroupId > 0) {
 $rids[] = $usergroupId;
 }
 }

 return $rids;
}


if ($ldapconn) {
 $ldapbind = @ldap_bind($ldapconn, $ldapun, $ldappw) or halt(7, "ldap_groups: ldap_bind failed.");
 if ($ldapbind) {
 get_groups(true, $ldapconn, $ldapdc, $groupfilter);
 
 
 if ($debug) echo "#DEBUG# LDAP bind successful";
 } else {
 if ($debug) echo "#DEBUG# LDAP bind failed";
 } 
}

if ($logging) fwrite($loghandler, date("d.m.y H:i:s")." done ldapgroupsync ...\r\n");

?>
