<?
define("PERM_JOB_LIST", 12);

GUIFactory::setMainGUI( "main" );
$main =& GUIFactory::getMainGUI();
$main->setUpdateInterval( $SCHEDULER_UPDATE_INTERVAL?$SCHEDULER_UPDATE_INTERVAL:30 );
$main->includeJS("jquery-1.6.1.min");
$main->includeJS("GTXScheduler");
node_class( "timeobject" );
node_class( "scheduler" );

$LAST_TASK_VIEW = 3;
load_menu( 872, $T_TASKADMIN, 0, i18n('view_task_schedule') );

$NODERELATED[$DO] = getTaskRelated($DO);

node_class( "systemreturncodeformatter" );

if ( $cmd == "chstate" )
{
 node_class( "sqltable" );
 $jobTable = new SqlTable( "job" );
 $jobs = $jobTable->findBy( "id", $id );
 $jobs[0]->setValue( "status", $jobs[0]->getValue("status")?0:1 );
 $jobs[0]->save();
}

class StatusFormatter extends ResultsetFormatter 
{
 var $d_jobTable;

 function StatusFormatter()
 {
 node_class( "sqltable" );
 $this->d_jobTable = new SqlTable( "job" );
 }

 function format( $rs )
 {
 $jobs = $this->d_jobTable->findBy( "id", $rs["id"] );
 $status = getJobStatus( $jobs[0] );

 if ($status != JOBSTATUS_RUNNING && Scheduler::getStatus() === SCHEDULER_STATUS_SUSPENDED &&
 !Scheduler::allowRun($rs["id"])) {
 return i18n("suspended") . " (" . translateJobStatus( $status ) . ")";
 }
 return translateJobStatus( $status ); 
 }
}

class AverageRunFormatter extends ResultsetFormatter 
{

 function format( $rs, $param )
 {
 
 
 
 
 
 
 return "<b>".i18n( "Runs" )."</b>: ".$rs["jobruncount"]."<br>".
 "<b>".i18n( "Average Duration" )."</b>: ".
 TimeObject::formatTimeDiffHours( $rs["jobrunaverage"] );
 }
}


class LastrunFormatter extends ResultsetFormatter 
{
 var $d_runTable;
 var $d_jobs = array();
 var $d_format;
 
 function LastrunFormatter()
 {
 node_class( "sqltable" );
 $this->d_runTable = new SqlTable( "jobrun" );
 $this->d_format = new SystemReturnCodeFormatter();
 }

 function format( $rs, $param )
 {
 global $DO;

 if ( !$this->d_jobs[$rs["id"]] )
 {
 
 $lastruns = $this->d_runTable->findBy( array("id"), array($rs["last_valid_jobrun_id"]), false, "starttime DESC", 1 );
 $this->d_jobs[$rs["id"]] =& $lastruns;
 }
 else
 $lastruns =& $this->d_jobs[$rs["id"]];
 if ( $param == "lastrun" || $param == "status" )
 {
 if ( count($lastruns) )
 {
 if ( $param == "lastrun" ) {
 $format = i18n('LOCALIZED_DATEFORMAT');
 if ($format == 'LOCALIZED_DATEFORMAT')
 $format = 'd.m.Y';
 $msg = date( "$format, H:i", $lastruns[0]->getValue( "starttime" ) );
 } else if ( $param == "status" ) {

 $rs = array("returnvalue"=>$lastruns[0]->getValue("returnvalue"), "output"=>$lastruns[0]->getValue("output"),
 "id"=>$lastruns[0]->getValue("id") );
 $msg = $this->d_format->format($rs, array("back"=>$DO) );
 
 }
 
 return $msg;
 }
 else
 return "---";
 }
 else if ( $param == "diff" )
 {
 if ( count( $lastruns ) ) {
 $end = $lastruns[0]->getValue( "endtime" );
 $start = $lastruns[0]->getValue( "starttime" );
 if ( $start >0 && $end > 0 )
 return TimeObject::formatTimeDiffHours( $end - $start );
 else return TimeObject::formatTimeDiffHours( time() - $start );
 }
 return "---";
 }
 }
}

class TypeFormatter extends ResultsetFormatter
{
 function format( $rs )
 {
 global $scheduleTypeClasses;
 return $scheduleTypeClasses[$rs["type"]]->getName();
 }
}


class DataFormatter extends ResultsetFormatter
{
 function format( $rs )
 {
 global $scheduleTypeClasses;
 $scheduleTypeClasses[$rs["type"]]->loadData( node_unserialize( $rs["data"] ) );
 return $scheduleTypeClasses[$rs["type"]]->getShortSummary();
 }
}

class ParallelFormatter extends ResultsetFormatter
{
 function format( $rs )
 {
 return ($rs["parallel"] == 1) ? i18n("yes") : i18n("no");
 }
}

function job_activate( $id, $value )
{
 global $USER_ID;
 
 $sql = "UPDATE job SET status=1 WHERE id=".sqlf_tl_num($id);
 query( $sql );

 $sql = "UPDATE job SET editor=".sqlf_tl_num($USER_ID)." where id=".sqlf_tl_num($id);
 query ($sql);

 $sql = "UPDATE job SET edate='".sqlf_escaped(time())."' where id=".sqlf_tl_num($id);
 query ($sql);
}

function job_deactivate( $id, $value )
{
 global $USER_ID;
 
 $sql = "UPDATE job SET status=0 WHERE id=".sqlf_tl_num($id);
 query( $sql );

 $sql = "UPDATE job SET editor=".sqlf_tl_num($USER_ID)." where id=".sqlf_tl_num($id);
 query ($sql);

 $sql = "UPDATE job SET edate='".sqlf_escaped(time())."' where id=".sqlf_tl_num($id);
 query ($sql);
}

function job_resetruns( $id, $value )
{
 global $USER_ID;
 
 $sql = "UPDATE jobrun SET valid=0 WHERE job_id=".sqlf_tl_num($id);
 query($sql);
 
 $sql = "UPDATE job SET editor=".sqlf_tl_num($USER_ID)." where id=".sqlf_tl_num($id);
 query ($sql);

 $sql = "UPDATE job SET edate='".sqlf_escaped(time())."' where id=".sqlf_tl_num($id);
 query ($sql);
}

function job_interact( $id, $value )
{
 global $FEATURE;

 node_class( "sqltable" );
 $jobtable = new SqlTable ( "job" );
 $jobs = $jobtable->findBy( "id", $id );
 $job = $jobs[0];
 $value["class"]->loadData( node_unserialize($job->getValue( "schedule_data" )) );
 $value["class"]->performAction( $value["action"] );
 $job->setValue( "schedule_data", node_serialize($value["class"]->getData()) );
 $job->save();
 if( $FEATURE['spawn_scheduler_on_interact'] ) {
 spawnNewScheduler();
 }
}

node_class( "commandaction" );
node_class( "userformatter" );
node_class( "dateformatter" );
node_include( "scheduletype" );


if ( perm($USER_ID, T_TASKADMIN, "", PERM_JOB_LIST) == 1 ) {
 $select = "job.id as id, job.status as jobstatus, job.name as jobname, job.parallel as parallel, task.name as taskname, ".
 "job.cdate as cdate, job.creator as creator, job.edate as edate, job.editor as editor, ".
 "job.schedule_type as type, job.schedule_data as data, job.jobruncount, job.jobrunaverage, job.last_valid_jobrun_id ";
 $from = "job, task";
 $where = "job.task_id = task.id";
 $groupby = "";
} else {
 $select = "job.id as id, job.status as jobstatus, job.name as jobname, job.parallel as parallel, task.name as taskname, ".
 "job.cdate as cdate, job.creator as creator, job.edate as edate, job.editor as editor, ".
 "job.schedule_type as type, job.schedule_data as data, job.jobruncount, job.jobrunaverage, job.last_valid_jobrun_id ";
 $from = "job, task, perm, user_group";
 $where = "user_group.user_id = ".sqlf_tl_num($USER_ID)." AND perm.usergroup_id = user_group.usergroup_id AND job.id = o_id AND o_type = ".sqlf_tl_num(T_JOB)." AND perm LIKE \"1%\"";
 $where .= " AND job.task_id = task.id";
 $groupby = "o_id";
}
if ( $SHOW_EMPTY_LIST ) {
 $where .= " AND 1 > 2";
}

$ds = new SQLDatasource( "taskds", $select, $from, $where, $groupby, "job.name" );
$ds->setDBHandle( $DB );


$ds->addColumn( "statusstr", i18n('sn_task_state'), true, false );
$ds->addColumn( "lnkjobname", i18n('sn_name'), true, "job.name", "job.name" );
$ds->addColumn( "taskname", i18n('sn_task'), true, "task.name", "task.name" );
$ds->addColumn( "parallel", "Parallel", true, "job.parallel", "job.parallel" );
$ds->addColumn( "ftype", i18n('sn_schedule'), true, "schedule_type", "schedule_type" );

$ds->addColumn( "lnklastrun", i18n('sn_task_last_run'), true, false, 'job.last_valid_jobrun_id' );
$ds->addColumn( "lastrunret", i18n("Status"), false, false, false );
$ds->addColumn( "lastrunspan", i18n("Duration"), false, false, false );

$ds->makeLink( "lnkjobname", "jobname", "do=871", "list", "id", "id" );
$ds->makeLink( "lnklastrun", "lastrun", "do=873", "list", "id", "id" );
$ds->setColumnAttribs( "lnkstatus", "width='90px'" ); 
$ds->addFormatter( "statusstr", new StatusFormatter() );
$lrFormatter = &new LastrunFormatter();
$ds->addFormatter( "lastrun", $lrFormatter, "lastrun" );
$ds->addFormatter( "lastrunspan", $lrFormatter, "diff" );
$ds->addFormatter( "lastrunret", $lrFormatter, "status" );
$ds->addFormatter( "cname", new UserFormatter( "creator", USERINFO_NAME ) );
$ds->addFormatter( "fcdate", new DateFormatter( "cdate" ) );
$ds->addFormatter( "ename", new UserFormatter( "editor", USERINFO_NAME ) );
$ds->addFormatter( "fedate", new DateFormatter( "edate" ) );
$ds->addFormatter( "ftype", new TypeFormatter() );
$ds->addFormatter( "fdata", new DataFormatter() );
$ds->addFormatter( "favg", new AverageRunFormatter() );
$ds->addFormatter( "parallel", new ParallelFormatter() );
$ds->setAss( "<b>" . i18n('sn_task_date') . "</b><br><br><b>ID:</b> \$id<br/><b>" . i18n('sn_name') . ":</b> \$jobname<br>".
 "<b>" . i18n('845.creator') . ":</b><br>\$fcdate (\$cname)<br>".
 "<b>" . i18n('last_edited') . ":</b><br>\$fedate (\$ename)<br>".
 "<b>" . i18n('sn_task_execution') . ":</b><br>".
 "\$fdata<br>".
 "\$favg" );
if (perm( $USER_ID, T_TASKADMIN, "", 13) ) {
 $ds->addAction( new CommandAction( $ICO_DELETE, "del", i18n('delete'), "cmd_job_del" ) );
 $ds->addAction( new CommandAction( null, "activate", i18n('sn_job_activate'), "job_activate" ) );
 $ds->addAction( new CommandAction( null, "deactivate", i18n('sn_job_deactivate'), "job_deactivate" ) );
 $ds->addAction( new CommandAction( null, "resetruns", i18n('sn_job_reset'), "job_resetruns" ) );
 if ($FEATURE["suspend_scheduler"] && perm($USER_ID, T_TASKADMIN, "", 2)) {
 global $I3_task_schedule_pv;
 $sstatus = Scheduler::getStatus();
 if (
 ($I3_task_schedule_pv == "resume_scheduler" || $sstatus == SCHEDULER_STATUS_RUNNING) 
 && $I3_task_schedule_pv != "suspend_scheduler"
 ) {
 $ds->addAction( new CommandAction( "?do=11&module=system&img=scheduler-status-button-suspended.gif", "suspend_scheduler", i18n("suspend_scheduler"), "suspend_scheduler" ) );
 } else if ($I3_task_schedule_pv == "suspend_scheduler"
 || $sstatus == SCHEDULER_STATUS_SUSPENDED
 || $sstatus == SCHEDULER_STATUS_SUSPENDING) {
 $ds->addAction( new CommandAction( "?do=11&module=system&img=scheduler-status-button-running.gif", "resume_scheduler", i18n("resume_scheduler"), "resume_scheduler" ) );
 }
 }
}

if (perm( $USER_ID, T_TASKADMIN, "", 13) ) {
 node_class( "singlecomparator" );
 foreach ( $scheduleTypeClasses as $key => $class )
 {
 $actions = $class->getActions();
 if ( is_array( $actions ) )
 {
 $c = new SingleComparator( $key );
 foreach ( $actions as $action )
 {
 $ds->addSingleAction( 
 new CommandAction( $action["icon"], "${key}_".$action["key"], 
 $action["descr"], "job_interact", 
 array("action"=>$action["key"],"class"=>$class) 
 ), 
 "type", $c );
 }
 } 
 }
}


$list = new ItemList3("task_schedule", $ds );
$list->setMaxListItems(50);
$list->setShowInfo( true );
$list->setGroupableColumns( array( 'ftype', 'taskname', 'statusstr' ) );

?>
